// ConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigDlg dialog


CConfigDlg::CConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigDlg)
	m_browserTitleStr = _T("");
	m_graphicsTitleStr = _T("");
	m_textTitleStr = _T("");
	//}}AFX_DATA_INIT
	m_openTextPathStr = _T("");
	m_openGraphicsPathStr = _T("");
	m_openBrowserPathStr = _T("");
}


void CConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDlg)
	DDX_Text(pDX, IDC_EDIT_OPEN_BROWSER, m_browserTitleStr);
	DDX_Text(pDX, IDC_EDIT_OPEN_GRAPHICS, m_graphicsTitleStr);
	DDX_Text(pDX, IDC_EDIT_OPEN_TEXT, m_textTitleStr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CConfigDlg)
	ON_BN_CLICKED(IDC_BUTTON_TEXT, OnButtonText)
	ON_BN_CLICKED(IDC_BUTTON_GRAPHICS, OnButtonGraphics)
	ON_BN_CLICKED(IDC_BUTTON_BROWSER, OnButtonBrowser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDlg message handlers

BOOL CConfigDlg::OnInitDialog() 
{
	char nameStr[_MAX_FNAME], extStr[_MAX_EXT ];

	_splitpath(m_openTextPathStr, NULL, NULL, nameStr, extStr);
	m_textTitleStr = nameStr;
	m_textTitleStr += extStr;
	
	_splitpath(m_openGraphicsPathStr, NULL, NULL, nameStr, extStr);
	m_graphicsTitleStr = nameStr;
	m_graphicsTitleStr += extStr;
	
	_splitpath(m_openBrowserPathStr, NULL, NULL, nameStr, extStr);
	m_browserTitleStr = nameStr;
	m_browserTitleStr += extStr;
	
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigDlg::OnButtonText() 
{
	UpdateData(TRUE);
	CString titleStr;
	CString openTextPathStr = GetExeFilePathName(CString(_T("Text File Viewer")), titleStr, m_openTextPathStr); 

	if(!openTextPathStr.IsEmpty())
	{
		m_openTextPathStr = openTextPathStr;
		m_textTitleStr = titleStr;
	}

	UpdateData(FALSE);
}

void CConfigDlg::OnButtonGraphics() 
{
	UpdateData(TRUE);
	CString titleStr;
	CString openGraphicsPathStr = GetExeFilePathName(CString(_T("Graphics File Viewer")), titleStr, m_openGraphicsPathStr);

	if(!openGraphicsPathStr.IsEmpty())
	{
		m_openGraphicsPathStr = openGraphicsPathStr;
		m_graphicsTitleStr = titleStr;
	}

	UpdateData(FALSE);
}

void CConfigDlg::OnButtonBrowser() 
{
	UpdateData(TRUE);
	CString titleStr;
	CString openBrowserPathStr = GetExeFilePathName(CString(_T("Browser")) ,titleStr, m_openBrowserPathStr);

	if(!openBrowserPathStr.IsEmpty())
	{
		m_openBrowserPathStr = openBrowserPathStr;
		m_browserTitleStr = titleStr;
	}

	UpdateData(FALSE);
}

CString CConfigDlg::GetExeFilePathName(CString titleBarStr, CString & strTitle, CString strCurrentPath)
{
	int n = strCurrentPath.ReverseFind('\\');
	CString strFileName((n >= 0) ? strCurrentPath.Mid(1 + n) : "");

	CFileDialog fDlg(TRUE, ".exe", strFileName, exeOpenFlags, exeOpenFilter, NULL);
		
	n = strCurrentPath.ReverseFind('\\');
	CString initDir = strCurrentPath.Left(n + 1);
	fDlg.m_ofn.lpstrInitialDir = (n >= 0) ? initDir : ".\\";
	fDlg.m_ofn.lpstrTitle = titleBarStr;

	if(IDOK == fDlg.DoModal())
	{
		strTitle = fDlg.GetFileName();
		return fDlg.GetPathName();
	}

	return CString("");
}
