// ExtensionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExtensionDlg dialog

CExtensionDlg::CExtensionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExtensionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExtensionDlg)
	m_editExtStr = _T("");
	//}}AFX_DATA_INIT
}

void CExtensionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExtensionDlg)
	DDX_Control(pDX, IDC_LIST_EXT, m_listBoxCtrl);
	DDX_Text(pDX, IDC_EDIT_EXT, m_editExtStr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExtensionDlg, CDialog)
	//{{AFX_MSG_MAP(CExtensionDlg)
	ON_LBN_SELCHANGE(IDC_LIST_EXT, OnSelchangeListExt)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	//}}AFX_MSG_MAP
//	ON_MESSAGE(WM_EXT_SET_SEL, OnSetExtSel)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExtensionDlg message handlers

BOOL CExtensionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int nStart = 0;
	int nSpace = m_asciiFileExtStr.Find(_T(' '), nStart); // a single blank separates extexsions
	int nCount = 0;

	while(nSpace > 0)
	{
		m_listBoxCtrl.AddString(m_asciiFileExtStr.Mid(nStart, nSpace - nStart));
		nStart = nSpace + 1;
		nSpace = m_asciiFileExtStr.Find(_T(' '), nStart);
		nCount++;
	}

	// initial selection is at zero index
	if(nCount > 0)
	{
		m_listBoxCtrl.SetCurSel(0);
		m_listBoxCtrl.GetText(0, m_editExtStr);
	}

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CExtensionDlg::OnSelchangeListExt() 
{
	int nSel = m_listBoxCtrl.GetCurSel();
	m_listBoxCtrl.GetText(nSel, m_editExtStr);
	UpdateData(FALSE);
}

void CExtensionDlg::OnButtonDelete() 
{
	UpdateData(TRUE);
	int nIndex = m_listBoxCtrl.FindString(-1, m_editExtStr);

	if(nIndex != LB_ERR)
	{
		int nRemain = m_listBoxCtrl.DeleteString(nIndex);

		if(nRemain > 0) // number remaining
		{
			nIndex = max(0, nIndex - 1); 
			m_listBoxCtrl.SetCurSel(nIndex);
			m_listBoxCtrl.GetText(nIndex, m_editExtStr);
		}
		else
		{
			m_editExtStr = _T("");
		}

		UpdateData(FALSE);
	}
}

void CExtensionDlg::OnButtonAdd() 
{
	UpdateData(TRUE);
	
	m_editExtStr.TrimLeft();
	m_editExtStr.TrimRight();
	m_editExtStr.MakeLower();

	if(m_editExtStr[0] == _T('.')) // strip a leading dot
	{
		m_editExtStr = m_editExtStr.Mid(1);
	}

	int nIndex = m_listBoxCtrl.FindString(-1, m_editExtStr);
	CString aStr;
	if(nIndex != LB_ERR) m_listBoxCtrl.GetText(nIndex, aStr);

	if(LB_ERR == nIndex || aStr != m_editExtStr) // not found, so add
	{  // must destinguish between html and htm
		m_listBoxCtrl.AddString(m_editExtStr);
	}

	nIndex = m_listBoxCtrl.FindString(-1, m_editExtStr);

	if(nIndex != LB_ERR)
	{
		m_listBoxCtrl.SetCurSel(nIndex);
	}

	UpdateData(FALSE);
}

void CExtensionDlg::OnOK() 
{
	m_asciiFileExtStr = _T("");
	int nCount = m_listBoxCtrl.GetCount();

	if(nCount > 0)
	{
		CString aStr;

		for(int i = 0; i < nCount; i++)
		{
			m_listBoxCtrl.GetText(i, aStr);
			m_asciiFileExtStr += aStr;
			m_asciiFileExtStr += _T(' ');
		}
	}
	
	CDialog::OnOK();
}
