#include "stdafx.h"
#include "MyIncludes.h"

CString GetLastErrorMessage()
{
	DWORD nErr = GetLastError();
	CString msgStr;

	if(nErr == ERROR_INTERNET_EXTENDED_ERROR)
	{
		DWORD dwError;
		char szBuffer[1024];
		DWORD dwBufferLength = sizeof(szBuffer);

		if(InternetGetLastResponseInfo(&dwError, szBuffer, &dwBufferLength))
		{
			 msgStr = szBuffer;
		}
	}
	else
	{
		LPVOID lpMsgBuf;

		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			nErr,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);

		msgStr = (LPCTSTR)lpMsgBuf;
		LocalFree(lpMsgBuf);
	}

	msgStr.TrimRight(); // remove CR-LF
	msgStr.TrimLeft();

	if(msgStr.IsEmpty())
	{
		msgStr.Format(_T("Last Error = %d"), nErr);
	}

	return msgStr;
}

void CMyInternetSession::OnStatusCallback(DWORD dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength )
{
#ifdef _DEBUG
	char const * const proc[] = {"none", "connection", "upload", "download"};
	char * pStr;

	switch(dwInternetStatus)
	{
		case INTERNET_STATUS_RESOLVING_NAME: pStr = "RESOLVING_NAME"; break;
		case INTERNET_STATUS_NAME_RESOLVED: pStr = "NAME_RESOLVED"; break;
		case INTERNET_STATUS_CONNECTING_TO_SERVER: pStr = "CONNECTING_TO_SERVER"; break;
		case INTERNET_STATUS_CONNECTED_TO_SERVER: pStr = "CONNECTED_TO_SERVER"; break;
		case INTERNET_STATUS_SENDING_REQUEST: pStr = "SENDING_REQUEST"; break;
		case INTERNET_STATUS_REQUEST_SENT: pStr = "REQUEST_SENT"; break;
		case INTERNET_STATUS_RECEIVING_RESPONSE: pStr = "RECEIVING_RESPONSE"; break;
		case INTERNET_STATUS_RESPONSE_RECEIVED: pStr = "RESPONSE_RECEIVED"; break;
		case INTERNET_STATUS_CTL_RESPONSE_RECEIVED: pStr = "CTL_RESPONSE_RECEIVED"; break;
		case INTERNET_STATUS_PREFETCH: pStr = "PREFETCH"; break;
		case INTERNET_STATUS_CLOSING_CONNECTION: pStr = "CLOSING_CONNECTION"; break;
		case INTERNET_STATUS_CONNECTION_CLOSED: pStr = "CONNECTION_CLOSED"; break;
		case INTERNET_STATUS_HANDLE_CREATED: pStr = "HANDLE_CREATED"; break;
		case INTERNET_STATUS_HANDLE_CLOSING: pStr = "HANDLE_CLOSING"; break;
		case INTERNET_STATUS_REQUEST_COMPLETE: pStr = "REQUEST_COMPLETE"; break;
		case INTERNET_STATUS_REDIRECT: pStr = "REDIRECT"; break;
		case INTERNET_STATUS_INTERMEDIATE_RESPONSE: pStr = "INTERMEDIATE_RESPONSE"; break;
		case INTERNET_STATUS_STATE_CHANGE: pStr = "STATE_CHANGE"; break;
	}

	TRACE("**** %s %s\n", proc[dwContext], pStr);
#endif
}

CMyInternetSession::CMyInternetSession(
		LPCTSTR pstrAgent,
		DWORD dwContext,
		DWORD dwAccessType,
		LPCTSTR pstrProxyName,
		LPCTSTR pstrProxyBypass,
		DWORD dwFlags) :
		CInternetSession(pstrAgent,
						 dwContext, 
						 dwAccessType, 
						 pstrProxyName, 
						 pstrProxyBypass, 
						 dwFlags)
		{}
