#ifndef MY_STUFF_H
#define MY_STUFF_H

// tooltip stuff
#define TOOLTIP_PIX_WIDTH 200 // pixels
#define TOOPTIP_INIT_DELAY 200 // ms
#define TOOLTIP_ON_TIME 5000 // ms

// up-dowmload chunks and progress steps
#define NUM_STEPS 20 // number of steps in progress ctrl
#define MIN_STEP_SIZE 1000
#define MAX_STEP_SIZE 1000000

enum {A_DIRECTORY = 0, A_FILE = 1};
#define EMPTY_DOMAIN_STR _T("\"") + enterNewDomainStr + _T("\" \"anonymous\" \"\" \"/\" \"21\"" "" "\\" "\\")

struct _item_data_
{
	DWORD dType; // 0 = Director, 1 = File
	CString nameStr; // dir or file name
	ULONG nSize; // file size bytes
	time_t time; // last modified time
};

struct _hdr_data_
{
	DWORD m_nSortOrder; // 0 = Ascending, 1 = Decending
	UINT m_index; // the column index 
};

template <class T> inline void Swap(T (& a), T (& b)) {T temp; temp = a; a = b; b = temp;}
#define NUM_ITEMS(a) (sizeof(a) / sizeof(a[0]))

const UINT exeOpenFlags   = OFN_EXPLORER | OFN_ENABLESIZING | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
char const * const exeOpenFilter = _T("Executable Files ( *.exe )|*.exe|")
								   _T("All Files ( *.* )|*.*||");

const CString enterNewDomainStr(_T("* Enter a new FTP domain *"));
const CString bannerStr(_T("To enter or change a FTP domain,\ntype over the info and then Login."));

const UINT myUploadFlags = OFN_EXPLORER | OFN_ENABLESIZING | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
char const * const myUploadFilter = _T("All Files ( *.* )|*.*||");
char const * const myUploadFileTitle = _T("DicksFTP - Upload");

const UINT myDownloadFlags = OFN_EXPLORER | OFN_ENABLESIZING | OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT;
char const * const myDownloadFilter = _T("All Files ( *.* )|*.*||");
char const * const myDownloadFileTitle = _T("InternetFTP - Download");

// Help string
char const _helpDocStr[] = _T("http://dickinsonian.com/programs/DicksFTPDoc.pdf#page=1&view=fitH");

// registry stuff
char const * const _settings = _T("settings");
char const * const _nDomains = _T("nDomains");
char const * const _nLastUsedDomain = _T("nLastUsedDomain");
char const * const _nAsciiBinaryAuto = _T("nAsciiBinaryAuto");
char const * const _bHidePswd = _T("bHidePswd");
char const * const _nXposition = _T("nXposition");
char const * const _nYposition = _T("nYposition");
char const * const _nNameColWidth = _T("nNameColWidth");
char const * const _nSizeColWidth = _T("nSizeColWidth");
char const * const _nTimeColWidth = _T("nTimeColWidth");
char const * const _asciiFileExt = _T("asciiFileExt");
char const * const _openTextPathStr = _T("openTextPathStr");
char const * const _openGraphicsPathStr = _T("openGraphicsPathStr");
char const * const _openBrowserPathStr = _T("openBrowserPathStr");

// user message
#define WM_USER_CLOSE_DROPDOWN (WM_USER + 5)
#define WM_USER_XFER_ERR_MSG (WM_USER + 6)
#define WM_USER_UPDATE_PROGRESS (WM_USER + 7)
#define WM_USER_XFER_COMPLETE (WM_USER + 8)
// Threads
UINT DownLoadThreadFcn(LPVOID pParam);
UINT UpLoadThreadFcn(LPVOID pParam);

typedef struct tagTHREADPARM
{
	BOOL bUpDn;	// either DOWNLOAD or UPLOAD
	BOOL * pbBusy; // TRUE locks out other server functions till transfer is complete
	HWND hWnd; // main dialog window
	CString localPathNameStr;
	CString sreverFileNameStr;
	CString msgStr;
	CString captionStr;
	int nSize; // bytes to transfer
	CFtpConnection * pFtpConnection;
	CInternetFile * pInternetFile;
	CCriticalSection cs;
} THREADPARMS;

CString GetLastErrorMessage();

class CMyInternetSession  : public CInternetSession
{
public:
	CMyInternetSession(
		LPCTSTR pstrAgent = NULL,
		DWORD dwContext = 1,
		DWORD dwAccessType = PRE_CONFIG_INTERNET_ACCESS,
		LPCTSTR pstrProxyName = NULL,
		LPCTSTR pstrProxyBypass = NULL,
		DWORD dwFlags = 0);

	virtual void OnStatusCallback(DWORD dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength );
};

enum _context_ {CONNECTION = 1, UPLOAD = 2, DOWNLOAD = 3};

#endif